<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <custom-card>
            <div class="mb-6">
                <div
                    class="mb-4"
                >
                    <form-input
                        v-model="declareFund"
                        type="number"
                        name="declare_fund"
                        :label="$t('trader_declare')"
                        placeholder="0.00"
                        :errors="errors && errors.declare_fund ? errors.declare_fund : null"
                        fund
                    />
                </div>
                <div
                    v-if="hasTraderDeclarePermission"
                    class="mb-4"
                >
                    <auto-button
                        @click="submitDeclareFund"
                    >
                        {{ $t('save_declare_fund') }}
                    </auto-button>
                </div>
            </div>
            <div
                class="custom-table"
            >
                <table class="styled-table">
                    <tbody>
                        <tr>
                            <td class="capitalize">
                                <div>{{ $t('current_fund_size') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(currentFundSize) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('p_l') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(pl) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('supposed_payable') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(supposedPayable) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('payable_allocation') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(payableAllocation) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('accu_allocation') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(accuAllocation) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('estimated_allocation') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(estimatedAllocation) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('allocation_balance') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(allocationBalance) }}</div>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </custom-card>
        <custom-card
            :title="new Date().getFullYear() + '-' + new Date().getMonth() + '-' + new Date().getDay()"
            class="mt-6"
        >
            <div
                class="custom-table"
            >
                <table class="styled-table">
                    <tbody>
                        <tr
                            v-for="plan in computedPlans"
                            :key="plan.id"
                        >
                            <td
                                class="align-middle text-sm font-black"
                            >
                                {{ plan.plan_name }}
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('captured_fund_size') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(plan.total_investments) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('weekly_min_roi_pay') }}</div>
                                <div class="font-black font-mono">{{ $helper.fundFormat(0) }}%</div>
                            </td>
                            <td class="capitalize">
                                <form-input
                                    v-model="adjustedPayRate[String(plan.code).toUpperCase()]"
                                    type="text"
                                    :name="`adjusted_pay_rate_${plan.id}`"
                                    :label="$t('adjusted_pay_rate')"
                                    :errors="errors && errors[`adjusted_pay_rate_${plan.code}`] ? errors[`adjusted_pay_rate_${plan.code}`] : null"
                                    placeholder="0.00"
                                />
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('adjusted_payable') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(plan.adjusted_min_pay_roi) }}</div>
                            </td>
                            <td class="capitalize">
                                <div>{{ $t('adjusted_comm_pay_max') }}</div>
                                <div class="font-black font-mono">$ {{ $helper.fundFormat(plan.adjusted_max_pay_comm) }}</div>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3"></td>
                            <td>
                                <div
                                    v-if="hasRoiAdjustmentPermission"
                                >
                                    <auto-button
                                        @click="submitRoiAdjustment"
                                    >
                                        {{ $t('save_roi_adjustment') }}
                                    </auto-button>
                                </div>
                            </td>
                            <td colspan="2"></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </custom-card>
        <div
            v-if="latestSetting"
            class="w-full mt-6"
        >
            <auto-button
                :type="parseInt(latestSetting.approved) === 0 ? 'primary' : 'danger'"
                @click="toggleApproved"
            >
                {{ parseInt(latestSetting.approved) === 0 ? $t('approve') : $t('undo_approve') }}
            </auto-button>
        </div>
    </div>
</template>

<script setup>
import {computed, inject, nextTick, onMounted, ref} from "vue";
import axios from "axios";
import CustomCard from "~/components/custom-card.vue";
import FormInput from "~/components/form/form-input.vue";
import AutoButton from "~/components/button/auto-button.vue";
import {useRouter} from "vue-router";
import BigNumber from "bignumber.js";
import {useAdminStore} from "~/stores/admin.js";

const $router = useRouter();
const $helper = inject('$helper');
const $adminStore = useAdminStore();
const $admin = computed(() => {
    return $adminStore.account;
});
const isSuperAdmin = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(1) || String($admin.value.type) === String(2);
});
const isDeveloper = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(2);
});
const permissions = computed(() => {
    return $adminStore.permissions;
});
const hasTraderDeclarePermission = computed(() => {
    if (isSuperAdmin.value || isDeveloper.value) return true;
    return !!permissions.value.includes('trader_declare');
});
const hasRoiAdjustmentPermission = computed(() => {
    if (isSuperAdmin.value || isDeveloper.value) return true;
    return !!permissions.value.includes('roi_adjustment');
});
const hasApproveRoiAdjustmentPermission = computed(() => {
    if (isSuperAdmin.value || isDeveloper.value) return true;
    return !!permissions.value.includes('approve_roi_adjustment');
});

const pageReady = ref(false);
const busy = ref(false);
const errors = ref({});

const planType = ref('structured');
const plans = ref([]);
const declareFund = ref('');
const latestSetting = ref(null);
const latestDailyReport = ref({});
const currentFundSize = computed(() => {
    return latestDailyReport.value.current_fund_size || 0;
});
const pl = computed(() => {
    return new BigNumber(declareFund.value || 0).minus(currentFundSize.value || 0).toNumber();
});
const supposedPayable = computed(() => {
    if (pl.value > 0) {
        return new BigNumber(pl.value).div(2).toNumber();
    }
    return 0;
});
const payableAllocation = computed(() => {
    return new BigNumber(declareFund.value || 0).minus(currentFundSize.value || 0).div(2).times(new BigNumber(totalCapturedFunds.value || 0).div(new BigNumber(currentFundSize.value || 0))).toNumber() || 0;
});
const accuAllocation = computed(() => {
    if (!latestDailyReport.value) return 0;
    return latestDailyReport.value.accumulate_allocation_balance;
});
const adjustedPayRate = ref({});
const totalCapturedFunds = computed(() => {
    return computedPlans.value.reduce((v, r) => {
        return new BigNumber(r.total_investments || 0).plus(v).toNumber();
    }, 0) || 0;
});
const estimatedAllocation = computed(() => {
    return computedPlans.value.reduce((total, plan) => {
        let adjusted = adjustedPayRate.value[String(plan.code).toUpperCase()];
        if (adjusted && adjusted !== 'undefined') {
            return total.plus(plan.adjusted_min_pay_roi).plus(plan.adjusted_max_pay_comm);
        } else {
            return total.plus(plan.min_pay_roi).plus(plan.max_pay_comm);
        }
    }, new BigNumber(0)).toNumber() || 0;
    // if (totalAdjustedPayout.value >= totalPayout.value) {
    //     return totalAdjustedPayout.value;
    // } else {
    //     return totalPayout.value;
    // }
});
const allocationBalance = computed(() => {
    return payableAllocation.value - estimatedAllocation.value;
});
const computedPlans = computed(() => {
    return plans.value.filter(r => {
        return String(r.setting.plan_type).toUpperCase() === String(planType.value).toUpperCase();
    }).map(plan => {
        let adjustedMinPayRoi = new BigNumber(0);
        let adjustedMaxPayComm = new BigNumber(0);
        if (typeof adjustedPayRate.value[plan.code] !== 'undefined') {
            adjustedMinPayRoi = adjustedMinPayRoi.plus(plan.total_investments).div(100).times(adjustedPayRate.value[plan.code]);
            if (adjustedPayRate.value[plan.code] > 0) {
                adjustedMaxPayComm = adjustedMinPayRoi.div(6).times(4);
            }
        }
        return {
            ...plan,
            adjusted_min_pay_roi: adjustedMinPayRoi || 0,
            adjusted_max_pay_comm: adjustedMaxPayComm || 0,
            total_investments: plan.total_investments || 0
        };
    }) || [];
});

const submitDeclareFund = async () => {
    if (!busy.value) {
        try {
            busy.value = true;
            errors.value = {};

            let fd = new FormData();
            fd.set('plan_type', planType.value);
            fd.set('declare_fund', declareFund.value);

            const data = await axios.post('/account/trader_declare/save_trader_declare', fd);

            await $helper.alertSuccess({
                message: data.message,
                callback: async () => {
                    pageReady.value = false;
                    await nextTick(async () => {
                        await loadData();
                        pageReady.value = true;
                    });
                }
            });
        } catch (error) {
            if (error.response.data.errors) {
                errors.value = error.response.data.errors;
            } else if (error.response) {
                // Request made and server responded
                console.log(error.response.data);
                console.log(error.response.status);
                console.log(error.response.headers);
            } else if (error.request) {
                // The request was made but no response was received
                console.log(error.request);
            } else {
                console.log(error);
                await $helper.alertError({message: error.message});
            }

            console.log(error);
            return Promise.reject(error);
        } finally {
            busy.value = false;
        }
    }
};

const submitRoiAdjustment = async () => {
    if (!busy.value) {
        try {
            busy.value = true;
            errors.value = {};

            let fd = new FormData();
            fd.set('plan_type', planType.value);
            computedPlans.value.forEach(r => {
                fd.set(`adjusted_pay_rate_${r.code}`, adjustedPayRate.value[r.code] || '');
            });

            const data = await axios.post('/account/trader_declare/save_roi_adjustment', fd);

            await $helper.alertSuccess({
                message: data.message,
                callback: async () => {
                    pageReady.value = false;
                    await nextTick(async () => {
                        await loadData();
                        pageReady.value = true;
                    });
                }
            });
        } catch (error) {
            if (error.response.data.errors) {
                errors.value = error.response.data.errors;
            } else if (error.response) {
                // Request made and server responded
                console.log(error.response.data);
                console.log(error.response.status);
                console.log(error.response.headers);
            } else if (error.request) {
                // The request was made but no response was received
                console.log(error.request);
            } else {
                console.log(error);
                await $helper.alertError({message: error.message});
            }

            console.log(error);
            return Promise.reject(error);
        } finally {
            busy.value = false;
        }
    }
};

const toggleApproved = async () => {
    if (!busy.value) {
        try {
            busy.value = true;
            errors.value = {};

            let fd = new FormData();
            fd.set('plan_type', planType.value);

            const data = await axios.post('/account/trader_declare/toggle_approve_declare', fd);

            await $helper.alertSuccess({
                message: data.message,
                callback: async () => {
                    pageReady.value = false;
                    await nextTick(async () => {
                        await loadData();
                        pageReady.value = true;
                    });
                }
            });
        } catch (error) {
            if (error.response.data.errors) {
                errors.value = error.response.data.errors;
            } else if (error.response) {
                // Request made and server responded
                console.log(error.response.data);
                console.log(error.response.status);
                console.log(error.response.headers);
            } else if (error.request) {
                // The request was made but no response was received
                console.log(error.request);
            } else {
                console.log(error);
                await $helper.alertError({message: error.message});
            }

            console.log(error);
            return Promise.reject(error);
        } finally {
            busy.value = false;
        }
    }
};

const loadData = async () => {
    try {
        const data = await axios.post('/account/trader_declare/build_form', {
            plan_type: planType.value
        });

        plans.value = data.plans;

        await nextTick(() => {
            if (data.setting) {
                declareFund.value = data.setting.declare_fund;
                computedPlans.value.forEach(p => {
                    let k = String(p.code).toUpperCase();
                    if (data.setting.adjusted_percentage && data.setting.adjusted_percentage && data.setting.adjusted_percentage[k]) {
                        adjustedPayRate.value[k] = data.setting.adjusted_percentage[k];
                    }
                });

                latestSetting.value = data.setting;
            }

            if (data.last_daily_report) {
                latestDailyReport.value = data.last_daily_report;
            }
        });
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    await loadData();
    pageReady.value = true;
});
</script>
